CREATE PROCEDURE usp_lsping 
( 
    @nf nchar = 'N' , 
    @wtn nchar = 'E' 
) 
WITH ENCRYPTION 
AS 
-- ===========================================================================
-- Author:Mark Huber
-- Version:1.0
-- Create date: Oct 19, 2011
-- Description:Description to ping the linked server and see if there alive
-- ===========================================================================
-- Parameters
-- @nf - did you want to be notified Y - yes N - no 
-- @wtn - when to notofiy E - on error S - on Succes B - on Both
--
-- EXAMPLE USE
--DECLARE@return_value int
--EXEC@return_value = [dbo].[usp_lsping]
--@nf = N'Y',
--@wtn = N'E'
--SELECT'Return Value' = @return_value
-- ===========================================================================
-- 
SET NOCOUNT ON 
BEGIN 
    DECLARE @LSrvrs TABLE 
    ( 
        SrvrID int IDENTITY ( 1 , 1 ) PRIMARY KEY , 
        SrvName nvarchar ( 128 ) 
    ) 

    INSERT INTO @LSrvrs 
    SELECT srvname FROM sys.sysservers WHERE srvname != convert ( nvarchar ( 128 ) , serverproperty ( 'servername' ) ) ; 
    ; 
    --

    DECLARE @maxloocnt int; 
    DECLARE @loopcnt int; 
    DECLARE @srvr nvarchar ( 128 ) ; 
    DECLARE @retval int; 
    DECLARE @Clr nvarchar ( 4 ) 
    DECLARE @msg nvarchar ( max ) 
    DECLARE @errchk int; 
    --
    SET @errchk = 0; 
    SET @Clr = char ( 13 ) + char ( 10 ) ; 
    SELECT @maxloocnt = count ( * ) FROM @LSrvrs; 

    SET @loopcnt = 1; 
    SET @msg = '' ; 
    SET @msg = @msg + '<Start>' + @Clr 
    WHILE @loopcnt <= @maxloocnt 
    BEGIN 
        SELECT @srvr = srvname FROM @LSrvrs WHERE SrvrID = @loopcnt; 
        --select @srvr

        BEGIN 
            try 

            EXEC @retval = sys.sp_testlinkedserver @srvr; 
        END 
        try 
        BEGIN 
            catch 
            SET @retval = sign ( @@error ) ; 
            SET @errchk = 99; 
        END 
        catch; 
        --if @retval =qwqw 0 
        SET @msg = @msg + @Clr + @srvr + ':' + cast ( @retval AS nvarchar ( 100 ) ) ; 
        SET @loopcnt = @loopcnt + 1; 
        end; 
        SET @msg = @msg + @Clr + '<end>' + @Clr 
        IF @nf = 'Y' 
        BEGIN 
            --if @wtn = 'E' or @wtn = 'S' or @wtn = 'B'
            --BEGIN
            --print 'WTN:'+@wtn
            --print '@errchk:'+ CONVERT(nvarchar(128),@errchk)
            IF ( @wtn = 'S' AND @errchk = 0 ) 
            OR 
            ( @wtn = 'E' AND @errchk > 0 ) 
            OR ( @wtn = 'B' ) 
            BEGIN 
                --select @msg;

                EXEC msdb.dbo.sp_send_dbmail 
                @recipients = N'mark.huber@bp.com' , @body = @msg , 
                @subject = 'Linked Server Ping' --,@query ='select @msg;', 
                --@attach_query_result_as_file = 1,@query_attachment_filename ='PingResults.txt'
                END; 
                --else
                -- BEGIN
                --
                -- END
            END 
            --end 
            --else
            --BEGIN
            -- '';
            --END;

        END 
        SET NOCOUNT OFF